# Fabric8-Launcher Backend Contributing Guide

If you're looking for a development guide for the Fabric8-Launcher Backend, first read [the readme](./README.md).

## First Steps

### Prerequisites

* Java 8+
* Maven 3.5.3+
* Git

### GitHub Workflow

To contribute to the Fabric8-Launcher Backend:

1. Fork this repository to your own Git.
2. Clone your fork.
3. Commit/Push your work on topic branches
4. Make pull requests.

Here are 3 simple rules we follow:
- Use a fork of our repository with a topic branch to contribute.
- Redact a nice commit/pull-request message following our [guide](./COMMIT_MSG.md).
- Try to keep a clean commit log (no unnecessary commits, no merge commits).

In order to make you feel safe regarding your contribution, we are here to help you:
 - Unit/Integration tests and checkstyle are run for every modification you make.
 - There is a test keeper plugin so you don't forget to test your changes if necessary.
 - Our team will review your contribution and help you to get your changes in.
 - For any question, you can comment your PR or Issue or send an email to [the team](mailto:fabric8-launcher@googlegroups.com).

Here are some articles we thought you might like:
- [Hub makes you better at GitHub](https://hub.github.com/).
- [Keep a clean git history](https://git-scm.com/book/en/v2/Git-Tools-Rewriting-History).
- [The most powerful git feature you're not using yet: git add -p](https://nuclearsquid.com/writings/git-add/).

## Build, Test and Run

You can find all those information in [the readme](./README.md#build-and-run-the-application).

## Choosing issues to work on

If you're wondering what issues would be suitable when you're just getting started, we recommend taking a look at the [issues](https://github.com/fabric8-launcher/launcher-application/issues) with the '[good first issue](https://github.com/fabric8-launcher/launcher-application/labels/good%20first%20issue)' and '[help wanted](https://github.com/fabric8-launcher/launcher-application/labels/help%20wanted)' labels.

## License Information and Contributor Agreement

* This project is under [Apache License Version 2.0](./LICENSE).
* There is no need to sign a contributor agreement to contribute to the Fabric8-Launcher.
* There is no need to add any specific license header to the source code.
