package io.fabric8.launcher.core.api.projectiles;

import javax.annotation.Nullable;

import io.fabric8.launcher.booster.catalog.rhoar.RhoarBooster;
import io.fabric8.launcher.core.api.Projectile;
import org.immutables.value.Value;

import static io.fabric8.launcher.service.git.GitEnvironment.LAUNCHER_BACKEND_GIT_REPOSITORY_DESCRIPTION;

/**
 * @author <a href="mailto:ggastald@redhat.com">George Gastaldi</a>
 */
public interface CreateProjectile extends Projectile {

    /**
     * @return The booster which this projectile refers to
     */
    @Nullable
    RhoarBooster getBooster();

    /**
     * @return The name to use in creating the new OpenShift project
     */
    @Nullable
    String getOpenShiftProjectName();

    /**
     * @return The name to use in creating the new Git projects
     */
    @Nullable
    String getGitRepositoryName();

    /**
     * @return The name to use for the location of the Git project
     */
    @Nullable
    String getGitOrganization();

    /**
     * @return The description used when creating the Git repository
     */
    @Value.Default
    default String getGitRepositoryDescription() {
        return LAUNCHER_BACKEND_GIT_REPOSITORY_DESCRIPTION.value("Generated by the Red Hat Developer Launcher (https://developers.redhat.com/launch)");
    }
}
